.nolist 
#include "ti84pce.inc" 
.list 
.org userMem-2 
.db tExtTok,tAsm84CeCmp 
.assume ADL=1 

PALETTE:
		ld      hl,$e00105
        ld     (hl),h
        ld      hl,$007200              ; inscrit la variable Ans
        ld      (OP1+1),hl              ; dans OP1
        ld      (OP1),hl               ; (correspond au call _AnsName)
        call    _RclVarSym              ; Que contient Ans ?..
        dec     a
        jr      z,Defini

paDef:  ld      bc,36 
        ld      hl,PalDat
        ld      de,$d07d00       ; adresse de la palette
        ldir
        ld      hl,$e00205
        ld     (hl),h
        ret

Defini: or      a
        sbc     hl,hl
        ld      a,(de)
        cp      36
        jr      c,infeg
        ld      a,36
infeg:  ld      ix,$d07d00
        ex      de,hl
        ld      de,3
Pal0Op: ld      (kcmp+1),a
        add     hl,de
        xor     a               ; directement le contenu d' OP1
        ld      e,(hl)          ; 128=1chiffre; 129=2chiffres; 130=3chiffres
        inc     hl
        rld
        bit     1,e
        jr      nz,TroisY
        bit     0,e
        jr      z,RaTTY
        ld      d,10
        ld      e,a
        mlt     de
        rld
        jr      brattY
TroisY: ld      b,100
        ld      c,a
        mlt     bc
        rld
        ld      d,10
        ld      e,a
        mlt     de
        inc     hl
        rld 
        dec     hl
        add     a,c
brattY: add     a,e             
RaTTY:  ld      (ix),a
        inc     ix
        ld      e,8
kcmp:   ld      a,0
        dec     a
        jr      nz,Pal0Op
        ld      hl,$e00205
        ld     (hl),h
        ret
PalDat: 
.db 2,24,224,0,152,68,194,96,16,59,231,255,222,148,74,41
.db 4,6,7,64,160,98,162,135,199,33,99,165,40,88,216
.db 31,191,22,150,246

